Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Attributes | List of all members
Botan::ECDH_PrivateKey Class Reference

`#include <ecdh.h>`

Inheritance diagram for Botan::ECDH_PrivateKey:

## Public Member Functions
std::string | algo_name () const override
AlgorithmIdentifier | algorithm_identifier () const override
bool | check_key (RandomNumberGenerator &rng, bool strong) const override
virtual std::unique_ptr< PK_Ops::Decryption > | create_decryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::Encryption > | create_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::KEM_Decryption > | create_kem_decryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::KEM_Encryption > | create_kem_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
std::unique_ptr< PK_Ops::Key_Agreement > | create_key_agreement_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const override
virtual std::unique_ptr< PK_Ops::Signature > | create_signature_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::Verification > | create_verification_op (const std::string &params, const std::string &provider) const
std::vector< uint8_t > | DER_domain () const
const EC_Group & | domain () const
EC_Group_Encoding | domain_format () const
| ECDH_PrivateKey (const AlgorithmIdentifier &alg_id, const secure_vector< uint8_t > &key_bits)
| ECDH_PrivateKey (RandomNumberGenerator &rng, const EC_Group &domain, const BigInt &x=0)
size_t | estimated_strength () const override
std::string | fingerprint (const std::string &alg="SHA") const
virtual OID | get_oid () const
size_t | key_length () const override
virtual size_t | message_part_size () const
virtual size_t | message_parts () const
virtual AlgorithmIdentifier | pkcs8_algorithm_identifier () const
secure_vector< uint8_t > | private_key_bits () const override
secure_vector< uint8_t > | private_key_info () const
const BigInt & | private_value () const
std::vector< uint8_t > | public_key_bits () const override
const PointGFp & | public_point () const
std::vector< uint8_t > | public_value () const override
std::vector< uint8_t > | public_value (PointGFp::Compression_Type type) const
void | set_parameter_encoding (EC_Group_Encoding enc)
std::vector< uint8_t > | subject_public_key () const

## Protected Attributes
EC_Group_Encoding | m_domain_encoding
EC_Group | m_domain_params
BigInt | m_private_key
PointGFp | m_public_key

## Detailed Description

This class represents ECDH Private Keys.

Definition at line 66 of file ecdh.h.

## Constructor & Destructor Documentation

Botan::ECDH_PrivateKey::ECDH_PrivateKey | ( | const AlgorithmIdentifier & | alg_id,
|  | const secure_vector< uint8_t > & | key_bits
| ) |  |
| inline

Load a private key.

Parameters

  alg_id | the X.509 algorithm identifier
  key_bits | ECPrivateKey bits

Definition at line 77 of file ecdh.h.

78 :
79 EC_PrivateKey(alg_id, key_bits) {}
Botan::EC_PrivateKey::EC_PrivateKey
EC_PrivateKey()=default

Botan::ECDH_PrivateKey::ECDH_PrivateKey | ( | RandomNumberGenerator & | rng,
|  | const EC_Group & | domain,
|  | const BigInt & | x = `0`
| ) |  |
| inline

Generate a new private key

Parameters

  rng | a random number generator
  domain | parameters to used for this key
  x | the private key; if zero, a new random key is generated

Definition at line 87 of file ecdh.h.

89 :
90 EC_PrivateKey(rng, domain, x) {}
Botan::EC_PrivateKey::EC_PrivateKey
EC_PrivateKey()=default
Botan::EC_PublicKey::domain
const EC_Group & domain() const
Definition: ecc_key.h:73

## Member Function Documentation

std::string Botan::ECDH_PublicKey::algo_name | ( |  | ) | const
| inline override virtual inherited

Get this keys algorithm name.

Returns
  this keys algorithm name

Implements Botan::Public_Key.

Definition at line 45 of file ecdh.h.

Referenced by create_key_agreement_op().

45 { return "ECDH"; }

AlgorithmIdentifier Botan::EC_PublicKey::algorithm_identifier | ( |  | ) | const
| override virtual inherited

Returns
  X.509 AlgorithmIdentifier for this key

Implements Botan::Public_Key.

Reimplemented in Botan::GOST_3410_PublicKey.

Definition at line 81 of file ecc_key.cpp.

References Botan::EC_PublicKey::DER_domain(), and Botan::Public_Key::get_oid().

Referenced by Botan::GOST_3410_PrivateKey::pkcs8_algorithm_identifier().

82 {
83 return AlgorithmIdentifier(get_oid(), DER_domain());
84 }
Botan::Public_Key::get_oid
virtual OID get_oid() const
Definition: pk_keys.cpp:30
Botan::EC_PublicKey::DER_domain
std::vector< uint8_t > DER_domain() const
Definition: ecc_key.h:85

bool Botan::EC_PublicKey::check_key | ( | RandomNumberGenerator & | rng,
|  | bool | strong
| ) |  | const
| override virtual inherited

Test the key values for consistency.

Parameters

  rng | rng to use
  strong | whether to perform strong and lengthy version of the test

Returns
  true if the test is passed

Implements Botan::Public_Key.

Reimplemented in Botan::ECDSA_PrivateKey, Botan::ECGDSA_PrivateKey, and Botan::ECKCDSA_PrivateKey.

Definition at line 47 of file ecc_key.cpp.

References Botan::EC_Group::get_cofactor(), Botan::EC_Group::get_order(), Botan::CT::is_zero(), Botan::PointGFp::is_zero(), Botan::EC_PublicKey::m_domain_params, Botan::PointGFp::on_the_curve(), Botan::EC_PublicKey::public_point(), and Botan::EC_Group::verify_group().

49 {
50 //verify domain parameters
51 if(!m_domain_params.verify_group(rng))
52 {
53 return false;
54 }
55 //check that public point is not at infinity
56 if(public_point().is_zero())
57 {
58 return false;
59 }
60 //check that public point is on the curve
61 if(!public_point().on_the_curve())
62 {
63 return false;
64 }
65 if(m_domain_params.get_cofactor() > 1)
66 {
67 if((public_point() * m_domain_params.get_cofactor()).is_zero())
68 {
69 return false;
70 }
71 //check that public point has order q
72 if(!(public_point() * m_domain_params.get_order()).is_zero())
73 {
74 return false;
75 }
76 }
77 return true;
78 }
Botan::EC_PublicKey::public_point
const PointGFp & public_point() const
Definition: ecc_key.h:58
Botan::EC_Group::get_order
const BigInt & get_order() const
Definition: ec_group.h:101
Botan::CT::is_zero
T is_zero(T x)
Definition: ct_utils.h:110
Botan::PointGFp::on_the_curve
bool on_the_curve() const
Definition: point_gfp.cpp:414
Botan::PointGFp::is_zero
bool is_zero() const
Definition: point_gfp.h:177
Botan::EC_Group::verify_group
bool verify_group(RandomNumberGenerator &rng, bool strong=false) const
Definition: ec_group.cpp:134
Botan::EC_PublicKey::m_domain_params
EC_Group m_domain_params
Definition: ecc_key.h:102
Botan::EC_Group::get_cofactor
const BigInt & get_cofactor() const
Definition: ec_group.h:107

std::unique_ptr< PK_Ops::Decryption > Botan::Private_Key::create_decryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an decryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::RSA_PrivateKey, and Botan::ElGamal_PrivateKey.

Definition at line 102 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Decryptor_EME::PK_Decryptor_EME().

105 {
106 throw Lookup_Error(algo_name() + " does not support decryption");
107 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

std::unique_ptr< PK_Ops::Encryption > Botan::Public_Key::create_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::RSA_PublicKey, and Botan::ElGamal_PublicKey.

Definition at line 79 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Encryptor_EME::PK_Encryptor_EME().

82 {
83 throw Lookup_Error(algo_name() + " does not support encryption");
84 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

std::unique_ptr< PK_Ops::KEM_Decryption > Botan::Private_Key::create_kem_decryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM decryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::RSA_PrivateKey, and Botan::McEliece_PrivateKey.

Definition at line 110 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_KEM_Decryptor::PK_KEM_Decryptor().

113 {
114 throw Lookup_Error(algo_name() + " does not support KEM decryption");
115 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

std::unique_ptr< PK_Ops::KEM_Encryption > Botan::Public_Key::create_kem_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::RSA_PublicKey, and Botan::McEliece_PublicKey.

Definition at line 87 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_KEM_Encryptor::PK_KEM_Encryptor().

90 {
91 throw Lookup_Error(algo_name() + " does not support KEM encryption");
92 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

std::unique_ptr< PK_Ops::Key_Agreement > Botan::ECDH_PrivateKey::create_key_agreement_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a key agreement operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Private_Key.

Definition at line 59 of file ecdh.cpp.

References Botan::ECDH_PublicKey::algo_name().

62 {
63 #if defined(BOTAN_HAS_OPENSSL)
64 if(provider == "openssl" || provider.empty())
65 {
66 try
67 {
68 return make_openssl_ecdh_ka_op(*this, params);
69 }
70 catch(Lookup_Error&)
71 {
72 if(provider == "openssl")
73 throw;
74 }
75 }
76 #endif
77
78 if(provider == "base" || provider.empty())
79 return std::unique_ptr<PK_Ops::Key_Agreement>(new ECDH_KA_Operation(*this, params, rng));
80
81 throw Provider_Not_Found(algo_name(), provider);
82 }
Botan::ECDH_PublicKey::algo_name
std::string algo_name() const override
Definition: ecdh.h:45

std::unique_ptr< PK_Ops::Signature > Botan::Private_Key::create_signature_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a signature operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::XMSS_WOTS_PrivateKey, Botan::XMSS_PrivateKey, Botan::TPM_PrivateKey, Botan::RSA_PrivateKey, Botan::GOST_3410_PrivateKey, Botan::ECDSA_PrivateKey, Botan::ECGDSA_PrivateKey, Botan::ECKCDSA_PrivateKey, and Botan::DSA_PrivateKey.

Definition at line 118 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Signer::PK_Signer().

121 {
122 throw Lookup_Error(algo_name() + " does not support signatures");
123 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

std::unique_ptr< PK_Ops::Verification > Botan::Public_Key::create_verification_op | ( | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a verification operation for this key/params or throw

Parameters

  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::XMSS_WOTS_PublicKey, Botan::XMSS_PublicKey, Botan::RSA_PublicKey, Botan::XMSS_WOTS_Addressed_PublicKey, Botan::GOST_3410_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, and Botan::DSA_PublicKey.

Definition at line 95 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Verifier::PK_Verifier().

97 {
98 throw Lookup_Error(algo_name() + " does not support verification");
99 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

std::vector<uint8_t> Botan::EC_PublicKey::DER_domain | ( |  | ) | const
| inline inherited

Return the DER encoding of this keys domain in whatever format is preset for this particular key

Definition at line 85 of file ecc_key.h.

Referenced by Botan::EC_PublicKey::algorithm_identifier().

86 { return domain().DER_encode(domain_format()); }
Botan::EC_PublicKey::domain
const EC_Group & domain() const
Definition: ecc_key.h:73
Botan::EC_Group::DER_encode
std::vector< uint8_t > DER_encode(EC_Group_Encoding form) const
Definition: ec_group.cpp:92
Botan::EC_PublicKey::domain_format
EC_Group_Encoding domain_format() const
Definition: ecc_key.h:92

const EC_Group& Botan::EC_PublicKey::domain | ( |  | ) | const
| inline inherited

Get the domain parameters of this key.

Exceptions

  Invalid_State | is thrown if the domain parameters of this point are not set

Returns
  the domain parameters of this key

Definition at line 73 of file ecc_key.h.

Referenced by Botan::GOST_3410_PublicKey::algorithm_identifier(), Botan::EC_PrivateKey::EC_PrivateKey(), Botan::EC_PublicKey::EC_PublicKey(), Botan::GOST_3410_PublicKey::GOST_3410_PublicKey(), and Botan::EC_PublicKey::key_length().

73 { return m_domain_params; }
Botan::EC_PublicKey::m_domain_params
EC_Group m_domain_params
Definition: ecc_key.h:102

EC_Group_Encoding Botan::EC_PublicKey::domain_format | ( |  | ) | const
| inline inherited

Get the domain parameter encoding to be used when encoding this key.

Returns
  the encoding to use

Definition at line 92 of file ecc_key.h.

93 { return m_domain_encoding; }
Botan::EC_PublicKey::m_domain_encoding
EC_Group_Encoding m_domain_encoding
Definition: ecc_key.h:104

size_t Botan::EC_PublicKey::estimated_strength | ( |  | ) | const
| override virtual inherited

Return the estimated strength of the underlying key against the best currently known attack. Note that this ignores anything but pure attacks against the key itself and do not take into account padding schemes, usage mistakes, etc which might reduce the strength. However it does suffice to provide an upper bound.

Returns
  estimated strength in bits

Implements Botan::Public_Key.

Definition at line 26 of file ecc_key.cpp.

References Botan::ecp_work_factor(), and Botan::EC_PublicKey::key_length().

27 {
28 return ecp_work_factor(key_length());
29 }
Botan::ecp_work_factor
size_t ecp_work_factor(size_t bits)
Definition: workfactor.cpp:14
Botan::EC_PublicKey::key_length
size_t key_length() const override
Definition: ecc_key.cpp:21

std::string Botan::Private_Key::fingerprint | ( | const std::string & | alg = `"SHA"` | ) | const
| inherited

Returns
  Hash of the PKCS #8 encoding for this key object

Definition at line 57 of file pk_keys.cpp.

References Botan::HashFunction::create(), hash, Botan::hex_encode(), and Botan::Private_Key::private_key_bits().

Referenced by Botan::Certificate_Store_In_SQL::find_certs_for_key(), Botan::Certificate_Store_In_SQL::insert_key(), and Botan::Certificate_Store_In_SQL::remove_key().

58 {
59 secure_vector<uint8_t> buf = private_key_bits();
60 std::unique_ptr<HashFunction> hash(HashFunction::create(alg));
61 hash->update(buf);
62 const auto hex_print = hex_encode(hash->final());
63
64 std::string formatted_print;
65
66 for(size_t i = 0; i != hex_print.size(); i += 2)
67 {
68 formatted_print.push_back(hex_print[i]);
69 formatted_print.push_back(hex_print[i+1]);
70
71 if(i != hex_print.size() - 2)
72 formatted_print.push_back(':');
73 }
74
75 return formatted_print;
76 }
Botan::Private_Key::private_key_bits
virtual secure_vector< uint8_t > private_key_bits() const =0
Botan::HashFunction::create
static std::unique_ptr< HashFunction > create(const std::string &algo_spec, const std::string &provider="")
Definition: hash.cpp:93
Botan::hex_encode
void hex_encode(char output[], const uint8_t input[], size_t input_length, bool uppercase)
Definition: hex.cpp:14
hash
MechanismType hash
Definition: p11_mechanism.cpp:63

OID Botan::Public_Key::get_oid | ( |  | ) | const
| virtual inherited

Get the OID of the underlying public key scheme.

Returns
  OID of the public key scheme

Reimplemented in Botan::XMSS_WOTS_Addressed_PublicKey.

Definition at line 30 of file pk_keys.cpp.

References Botan::Public_Key::algo_name(), and Botan::OIDS::lookup().

Referenced by Botan::DL_Scheme_PublicKey::algorithm_identifier(), Botan::Curve25519_PublicKey::algorithm_identifier(), Botan::McEliece_PublicKey::algorithm_identifier(), Botan::RSA_PublicKey::algorithm_identifier(), Botan::GOST_3410_PublicKey::algorithm_identifier(), Botan::EC_PublicKey::algorithm_identifier(), Botan::TPM_PrivateKey::algorithm_identifier(), and Botan::XMSS_WOTS_Addressed_PublicKey::get_oid().

31 {
32 try {
33 return OIDS::lookup(algo_name());
34 }
35 catch(Lookup_Error&)
36 {
37 throw Lookup_Error("PK algo " + algo_name() + " has no defined OIDs");
38 }
39 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0
Botan::OIDS::lookup
std::string lookup(const OID &oid)
Definition: oids.cpp:18

size_t Botan::EC_PublicKey::key_length | ( |  | ) | const
| override virtual inherited

Return an integer value best approximating the length of the primary security parameter. For example for RSA this will be the size of the modulus, for ECDSA the size of the ECC group, and for McEliece the size of the code will be returned.

Implements Botan::Public_Key.

Definition at line 21 of file ecc_key.cpp.

References Botan::BigInt::bits(), Botan::EC_PublicKey::domain(), Botan::EC_Group::get_curve(), and Botan::CurveGFp::get_p().

Referenced by Botan::EC_PublicKey::estimated_strength().

22 {
23 return domain().get_curve().get_p().bits();
24 }
Botan::EC_PublicKey::domain
const EC_Group & domain() const
Definition: ecc_key.h:73
Botan::BigInt::bits
size_t bits() const
Definition: bigint.cpp:184
Botan::EC_Group::get_curve
const CurveGFp & get_curve() const
Definition: ec_group.h:89
Botan::CurveGFp::get_p
const BigInt & get_p() const
Definition: curve_gfp.h:91

virtual size_t Botan::Public_Key::message_part_size | ( |  | ) | const
| inline virtual inherited

Returns how large each of the message parts refered to by message_parts() is

This function is public but applications should have few reasons to ever call this.

Returns
  size of the message parts in bits

Reimplemented in Botan::GOST_3410_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, and Botan::DSA_PublicKey.

Definition at line 114 of file pk_keys.h.

Referenced by Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

114 { return 0; }

virtual size_t Botan::Public_Key::message_parts | ( |  | ) | const
| inline virtual inherited

Returns more than 1 if the output of this algorithm (ciphertext, signature) should be treated as more than one value. This is used for algorithms like DSA and ECDSA, where the (r,s) output pair can be encoded as either a plain binary list or a TLV tagged DER encoding depending on the protocol.

This function is public but applications should have few reasons to ever call this.

Returns
  number of message parts

Reimplemented in Botan::GOST_3410_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, and Botan::DSA_PublicKey.

Definition at line 103 of file pk_keys.h.

Referenced by Botan::X509_Object::check_signature(), Botan::choose_sig_format(), Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

103 { return 1; }

virtual AlgorithmIdentifier Botan::Private_Key::pkcs8_algorithm_identifier | ( |  | ) | const
| inline virtual inherited

Returns
  PKCS #8 AlgorithmIdentifier for this key Might be different from the X.509 identifier, but normally is not

Reimplemented in Botan::XMSS_WOTS_PrivateKey, Botan::GOST_3410_PrivateKey, and Botan::XMSS_WOTS_Addressed_PrivateKey.

Definition at line 188 of file pk_keys.h.

Referenced by Botan::Private_Key::private_key_info().

189 { return algorithm_identifier(); }
Botan::Public_Key::algorithm_identifier
virtual AlgorithmIdentifier algorithm_identifier() const =0

secure_vector< uint8_t > Botan::EC_PrivateKey::private_key_bits | ( |  | ) | const
| override virtual inherited

Returns
  BER encoded private key bits

Implements Botan::Private_Key.

Definition at line 141 of file ecc_key.cpp.

References Botan::BigInt::bytes(), Botan::DER_Encoder::encode(), Botan::BigInt::encode_1363(), Botan::DER_Encoder::end_cons(), Botan::DER_Encoder::get_contents(), Botan::EC_PrivateKey::m_private_key, Botan::OCTET_STRING, Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

142 {
143 return DER_Encoder()
144 .start_cons(SEQUENCE)
145 .encode(static_cast<size_t>(1))
146 .encode(BigInt::encode_1363(m_private_key, m_private_key.bytes()),
147 OCTET_STRING)
148 .end_cons()
149 .get_contents();
150 }
Botan::EC_PrivateKey::m_private_key
BigInt m_private_key
Definition: ecc_key.h:154
Botan::OCTET_STRING
Definition: asn1_obj.h:35
Botan::SEQUENCE
Definition: asn1_obj.h:39
Botan::BigInt::encode_1363
static secure_vector< uint8_t > encode_1363(const BigInt &n, size_t bytes)
Definition: big_code.cpp:82
Botan::BigInt::bytes
size_t bytes() const
Definition: bigint.cpp:176

secure_vector< uint8_t > Botan::Private_Key::private_key_info | ( |  | ) | const
| inherited

Returns
  PKCS #8 private key encoding for this key object

Definition at line 41 of file pk_keys.cpp.

References Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::DER_Encoder::get_contents(), Botan::OCTET_STRING, Botan::Private_Key::pkcs8_algorithm_identifier(), Botan::Private_Key::private_key_bits(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

Referenced by Botan::PKCS8::BER_encode(), Botan::PKCS8::BER_encode_encrypted_pbkdf_iter(), and Botan::PKCS8::BER_encode_encrypted_pbkdf_msec().

42 {
43 const size_t PKCS8_VERSION = 0;
44
45 return DER_Encoder()
46 .start_cons(SEQUENCE)
47 .encode(PKCS8_VERSION)
48 .encode(pkcs8_algorithm_identifier())
49 .encode(private_key_bits(), OCTET_STRING)
50 .end_cons()
51 .get_contents();
52 }
Botan::Private_Key::private_key_bits
virtual secure_vector< uint8_t > private_key_bits() const =0
Botan::OCTET_STRING
Definition: asn1_obj.h:35
Botan::Private_Key::pkcs8_algorithm_identifier
virtual AlgorithmIdentifier pkcs8_algorithm_identifier() const
Definition: pk_keys.h:188
Botan::SEQUENCE
Definition: asn1_obj.h:39

const BigInt & Botan::EC_PrivateKey::private_value | ( |  | ) | const
| inherited

Get the private key value of this key object.

Returns
  the private key value of this key object

Definition at line 106 of file ecc_key.cpp.

References Botan::EC_PrivateKey::m_private_key.

107 {
108 if(m_private_key == 0)
109 throw Invalid_State("EC_PrivateKey::private_value - uninitialized");
110
111 return m_private_key;
112 }
Botan::EC_PrivateKey::m_private_key
BigInt m_private_key
Definition: ecc_key.h:154

std::vector< uint8_t > Botan::EC_PublicKey::public_key_bits | ( |  | ) | const
| override virtual inherited

Returns
  BER encoded public key bits

Implements Botan::Public_Key.

Reimplemented in Botan::GOST_3410_PublicKey.

Definition at line 86 of file ecc_key.cpp.

References Botan::PointGFp::COMPRESSED, Botan::EC2OSP(), Botan::EC_PublicKey::public_point(), and Botan::unlock().

Referenced by Botan::EC_PrivateKey::EC_PrivateKey().

87 {
88 return unlock(EC2OSP(public_point(), PointGFp::COMPRESSED));
89 }
Botan::PointGFp::COMPRESSED
Definition: point_gfp.h:46
Botan::EC2OSP
secure_vector< uint8_t > EC2OSP(const PointGFp &point, uint8_t format)
Definition: point_gfp.cpp:470
Botan::EC_PublicKey::public_point
const PointGFp & public_point() const
Definition: ecc_key.h:58
Botan::unlock
std::vector< T > unlock(const secure_vector< T > &in)
Definition: secmem.h:125

const PointGFp& Botan::EC_PublicKey::public_point | ( |  | ) | const
| inline inherited

Get the public point of this key.

Exceptions

  Invalid_State | is thrown if the domain parameters of this point are not set

Returns
  the public point of this key

Definition at line 58 of file ecc_key.h.

Referenced by Botan::EC_PublicKey::check_key(), Botan::ECGDSA_PrivateKey::check_key(), Botan::ECKCDSA_PrivateKey::check_key(), Botan::ECDSA_PrivateKey::check_key(), Botan::EC_PublicKey::EC_PublicKey(), Botan::GOST_3410_PublicKey::public_key_bits(), and Botan::EC_PublicKey::public_key_bits().

58 { return m_public_key; }
Botan::EC_PublicKey::m_public_key
PointGFp m_public_key
Definition: ecc_key.h:103

std::vector<uint8_t> Botan::ECDH_PrivateKey::public_value | ( |  | ) | const
| inline override virtual

Implements Botan::PK_Key_Agreement_Key.

Definition at line 92 of file ecdh.h.

References Botan::ECDH_PublicKey::public_value(), and Botan::PointGFp::UNCOMPRESSED.

Referenced by Botan::TLS::Client_Key_Exchange::Client_Key_Exchange().

93 { return ECDH_PublicKey::public_value(PointGFp::UNCOMPRESSED); }
Botan::ECDH_PublicKey::public_value
std::vector< uint8_t > public_value() const
Definition: ecdh.h:50
Botan::PointGFp::UNCOMPRESSED
Definition: point_gfp.h:45

std::vector<uint8_t> Botan::ECDH_PrivateKey::public_value | ( | PointGFp::Compression_Type | type | ) | const
| inline

Definition at line 95 of file ecdh.h.

References Botan::ECDH_PublicKey::public_value().

96 { return ECDH_PublicKey::public_value(type); }
Botan::ECDH_PublicKey::public_value
std::vector< uint8_t > public_value() const
Definition: ecdh.h:50
type
MechanismType type
Definition: p11_mechanism.cpp:43

void Botan::EC_PublicKey::set_parameter_encoding | ( | EC_Group_Encoding | enc | ) |
| inherited

Set the domain parameter encoding to be used when encoding this key.

Parameters

  enc | the encoding to use

Definition at line 91 of file ecc_key.cpp.

References Botan::EC_DOMPAR_ENC_EXPLICIT, Botan::EC_DOMPAR_ENC_IMPLICITCA, Botan::EC_DOMPAR_ENC_OID, Botan::EC_Group::get_oid(), Botan::EC_PublicKey::m_domain_encoding, and Botan::EC_PublicKey::m_domain_params.

92 {
93 if(form != EC_DOMPAR_ENC_EXPLICIT &&
94 form != EC_DOMPAR_ENC_IMPLICITCA &&
95 form != EC_DOMPAR_ENC_OID)
96 throw Invalid_Argument("Invalid encoding form for EC-key object specified");
97
98 if((form == EC_DOMPAR_ENC_OID) && (m_domain_params.get_oid() == ""))
99 throw Invalid_Argument("Invalid encoding form OID specified for "
100 "EC-key object whose corresponding domain "
101 "parameters are without oid");
102
103 m_domain_encoding = form;
104 }
Botan::EC_Group::get_oid
std::string get_oid() const
Definition: ec_group.h:115
Botan::EC_DOMPAR_ENC_EXPLICIT
Definition: ec_group.h:23
Botan::EC_DOMPAR_ENC_IMPLICITCA
Definition: ec_group.h:24
Botan::EC_DOMPAR_ENC_OID
Definition: ec_group.h:25
Botan::EC_PublicKey::m_domain_params
EC_Group m_domain_params
Definition: ecc_key.h:102
Botan::EC_PublicKey::m_domain_encoding
EC_Group_Encoding m_domain_encoding
Definition: ecc_key.h:104

std::vector< uint8_t > Botan::Public_Key::subject_public_key | ( |  | ) | const
| inherited

Returns
  X.509 subject key encoding for this key object

Definition at line 17 of file pk_keys.cpp.

References Botan::Public_Key::algorithm_identifier(), Botan::BIT_STRING, Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::DER_Encoder::get_contents_unlocked(), Botan::Public_Key::public_key_bits(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

Referenced by Botan::X509::BER_encode(), and Botan::X509::PEM_encode().

18 {
19 return DER_Encoder()
20 .start_cons(SEQUENCE)
21 .encode(algorithm_identifier())
22 .encode(public_key_bits(), BIT_STRING)
23 .end_cons()
24 .get_contents_unlocked();
25 }
Botan::Public_Key::public_key_bits
virtual std::vector< uint8_t > public_key_bits() const =0
Botan::Public_Key::algorithm_identifier
virtual AlgorithmIdentifier algorithm_identifier() const =0
Botan::SEQUENCE
Definition: asn1_obj.h:39
Botan::BIT_STRING
Definition: asn1_obj.h:34

## Member Data Documentation

EC_Group_Encoding Botan::EC_PublicKey::m_domain_encoding
| protected inherited

Definition at line 104 of file ecc_key.h.

Referenced by Botan::EC_PrivateKey::EC_PrivateKey(), and Botan::EC_PublicKey::set_parameter_encoding().

EC_Group Botan::EC_PublicKey::m_domain_params
| protected inherited

Definition at line 102 of file ecc_key.h.

Referenced by Botan::EC_PublicKey::check_key(), Botan::EC_PrivateKey::EC_PrivateKey(), Botan::GOST_3410_PublicKey::GOST_3410_PublicKey(), and Botan::EC_PublicKey::set_parameter_encoding().

BigInt Botan::EC_PrivateKey::m_private_key
| protected inherited

Definition at line 154 of file ecc_key.h.

Referenced by Botan::EC_PrivateKey::EC_PrivateKey(), Botan::EC_PrivateKey::private_key_bits(), and Botan::EC_PrivateKey::private_value().

PointGFp Botan::EC_PublicKey::m_public_key
| protected inherited

Definition at line 103 of file ecc_key.h.

Referenced by Botan::EC_PrivateKey::EC_PrivateKey(), and Botan::GOST_3410_PublicKey::GOST_3410_PublicKey().

The documentation for this class was generated from the following files:

- src/lib/pubkey/ecdh/ecdh.h
- src/lib/pubkey/ecdh/ecdh.cpp